import { IPromise } from '@mezzy/result';
import { Signal } from '@mezzy/signals';
import { HiResTimer } from '@mezzy/timer';
import { CommandManager } from '@mezzy/commands';
import IProgressRunFunction from './iProgressRunFunction';
import ProgressCommand from './progressCommand';
import ProgressReport from './progressReport';
export declare class ProgressTracker {
    constructor(timer?: HiResTimer, parentCommand?: ProgressCommand, message?: string);
    private _startTime;
    private _timeLastStepCompleted;
    readonly timer: HiResTimer;
    private _timer;
    readonly parentCommand: ProgressCommand;
    private _parentCommand;
    readonly stepsTotal: number;
    private _stepsTotal;
    readonly stepCurrent: number;
    private _stepCurrent;
    readonly weightTotal: number;
    private _weightTotal;
    readonly weightCompleted: number;
    private _weightCompleted;
    message: string;
    readonly commands: CommandManager;
    private _commands;
    readonly lastReturnValue: any;
    readonly isCompleted: boolean;
    private _isCompleted;
    progressed: Signal<ProgressReport>;
    completed: Signal<ProgressReport>;
    queue(runFunction: IProgressRunFunction, scope: any, message?: string, weight?: number): ProgressTracker;
    queueCommand(command: ProgressCommand, runArgs?: any[]): ProgressTracker;
    run(): IPromise<any>;
    private _createCommand;
    private _reportProgressCommandStart;
    private _reportProgressCommandComplete;
    private _reportProgress;
    private _reportSubTrackerProgress;
    private _reportCompleted;
}
export default ProgressTracker;
